#include <SPI.h>
#include <WiFi.h>

char ssid[] = "planexuserwpa";
		// 接続するWi-Fi アクセスポイントの名前
char pass[] = "1234567890"; // パスワード
int status = WL_IDLE_STATUS;
WiFiServer server(8080);

int led1;

void setup() {
  Serial.begin(9600); // シリアル通信の速度
  while (!Serial); // シリアル通信が確立するまで待つ
  Serial.println("Edison start");
  while ( status != WL_CONNECTED) {
    status = WiFi.begin(ssid, pass);
    delay(1000);
  }
  Serial.println(WiFi.localIP());
  server.begin(); // Web サーバのスタート

  pinMode(13, OUTPUT); // 書かれている位置を変更
  led1 = 0;
}

void loop() {
  WiFiClient client = server.available();
		// 接続しているクライアントを取得する
  if (client) { // 何か送られてきていれば以下を実行する
    Serial.println("new client");
		// シリアルモニタにnew client と表示
    String currentLine = ""; // 受信データの初期化
    while (client.connected()) {
		// 通信がつながっていれば以下を繰り返す
      if (client.available()) {
		// 何か送られてきていれば以下を実行する
        char c = client.read(); // 1 バイト読み込む
        Serial.write(c); // シリアルモニタにその文字を表示する
        if (c == '\n') { // もし￥n（改行コード）だったら
          Recieve(currentLine);
		// データを解析するためにRecieve 関数へ
          if (currentLine.length() == 0) {
		// 受信データの長さが0 だったら（最終行だったら）
            EdisonBoard(); // EdisonBoard 関数へ
            DisplayHTML(client);
		// 画面表示を更新するためにDisplayHTML 関数へ
            break;
          }
          else {
		// 受信データがの長さが0 でなかったら受信データを初期化
            currentLine = "";
          }
        }
        else if (c != '\r') { // \n でも￥r でもなければ
          currentLine += c;
		// 受信データをcurrentLine につなげる
        }

      }
    }
    client.stop(); // 通信が終わったときの処理
    Serial.println("client disconnected");
		// シリアルモニタにclient disconnected と表示
    }
  delay(10);
}
//【 通信】
void Recieve(String currentLine)
{
  if (int(currentLine.indexOf("GET /?H")) != -1) {
		// 受信データに「GET /?H」が含まれていれば
    led1 = 1;
  }
  if (int(currentLine.indexOf("GET /?L")) != -1) {
		// 受信データに「GET /?L」が含まれていれば
    led1 = 0;
  }
}
//【 回路】リスト 4.2 を参照
void EdisonBoard()
{
  if (led1 == 1) {
    digitalWrite(13, HIGH); // 点灯
  }
  if (led1 == 0) {
    digitalWrite(13, LOW); // 消灯
  }
}
//【 画面】リスト 4.3 を参照
void DisplayHTML(WiFiClient client)
{
  client.println("<!DOCTYPE html>");
  client.println("<html>");
  client.println("<head>");
  client.println("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">");
  client.println("<title> LED の点灯と消灯 </title>");
  client.println("</head>");
  client.println("<body>");
  client.println("Click <a href=\"?H\">here</a> 点灯<br>");
  client.println("Click <a href=\"?L\">here</a> 消灯<br>");
  client.println("</body>");
  client.println("</html>");
}
