#include <SPI.h>
#include <WiFi.h>

char ssid[] = "planexuserwpa"; // Wi-Fi アクセスポイントの名前
char pass[] = "1234567890"; // パスワード
int keyIndex = 0;
int status = WL_IDLE_STATUS;
WiFiServer server(8080);

boolean led1 = false;
boolean led2 = false;
boolean led3 = false;
int select1 = 1;

void setup() {
  pinMode(3, OUTPUT); // 出力に設定
  pinMode(6, OUTPUT); // 出力に設定
  pinMode(9, OUTPUT); // 出力に設定
  Serial.begin(9600); // シリアル通信の通信速度を9600bps に設定
  while (!Serial); // シリアル通信が確立するまで待つ

  Serial.println("Edison start");
  while ( status != WL_CONNECTED) {
		// Wi-Fi 接続ができるまで繰り返す
    status = WiFi.begin(ssid, pass); // Wi-Fi で接続
    delay(1000); // 1 秒待つ
  }
  Serial.println(WiFi.localIP());
		// IP アドレスをシリアルモニタに表示
  server.begin(); // Wi-Fi 接続の開始
}

void loop() {
  WiFiClient client = server.available();
		// 接続しているクライアントを取得する
  if (client) { // 何か送られてきていれば以下を実行する
    Serial.println("new client");
		// シリアルモニタにnew client と表示
    String currentLine = ""; // 受信データの初期化
    while (client.connected()) {
		// 通信がつながっていれば以下を繰り返す
      if (client.available()) {
		// 何か送られてきていれば以下を実行する
        char c = client.read();	// 1 バイト読み込む
        Serial.write(c); // シリアルモニタにその文字を表示する
          if (c == '\n') { // もし￥n（改行コード）だったら
            Recieve(currentLine);
		// データを解析するためにRecieve 関数へ
            if (currentLine.length() == 0) {
		// 受信データの長さが0 だったら（最終行だったら）
              EdisonBoard(); // EdisonBoard 関数へ
            DisplayHTML(client);
		// 画面表示を更新するためにDisplayHTML 関数へ
            break;
          }
          else { // 受信データの長さが0 でなかったら受信データを初期化
            currentLine = "";
          }
        }
        else if (c != '\r') { // \n でも\r でもなければ
          currentLine += c;
		// 受信データをcurrentLine につなげる
        }

      }
    }
    client.stop(); // 通信が終わったときの処理
    Serial.println("client disconnected");
		// シリアルモニタにclient disconnected と表示
  }
  delay(10);
}
//【 通信】
void Recieve(String currentLine)
{
  int i = 0, n;
  if (int(currentLine.indexOf("GET /?C1")) != -1) {
		// 受信データに「GET /?C1」が含まれていれば
    if (led1 == true)led1 = false; // led1 の値を反転させる
    else led1 = true;
  }
  else if (int(currentLine.indexOf("GET /?C2"))
    != -1) { // C1 と同様
    if (led2 == true)led2 = false;
    else led2 = true;
  }
  else if (int(currentLine.indexOf("GET /?C3"))
    != -1) { // C1 と同様
    if (led3 == true)led3 = false;
    else led3 = true;
  }
  else if (int(currentLine.indexOf("GET /?R1"))
    != -1) { // 受信データに「GET /?R1」が含まれていれば
    select1 = 1; // 明るさを決める変数を更新
  }
  else if (int(currentLine.indexOf("GET /?R2"))
    != -1) { // R1 と同様
    select1 = 2;
  }
  else if (int(currentLine.indexOf("GET /?R3"))
    != -1) { // R1 と同様
    select1 = 3;
  }
  return;
}
//【 回路】リスト 4.4 を参照
void EdisonBoard()
{
  int a = 255 / (select1 * select1);
  if (led1 == true) {
    analogWrite(3, a);
  }
  else {
    digitalWrite(3, LOW);
  }
  if (led2 == true) {
    analogWrite(6, a);
  }
  else {
    digitalWrite(6, LOW);
  }
  if (led3 == true) {
    analogWrite(9, a);
  }
  else {
    digitalWrite(9, LOW);
  }
}
//【 画面】リスト 4.5 を参照
void DisplayHTML(WiFiClient client)
{
  client.println("<!DOCTYPE html>");
  client.println("<html>");
  client.println("<head>");
  client.println("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">");
  client.println("<title> チェックボックスとラジオボタンでLED の点灯・消灯</title>");
  client.println("</html>");
  client.println("<body>");
  client.print("<P>LED の選択<br>");
  client.print("<input type=\"checkbox\" name=\"CHECK\" onclick=\"location.href='?C1'\"");
  if (led1 == true) {
    client.print(" checked");
  }
  client.print(">Led1<br>");
  client.print("<input type=\"checkbox\" name=\"CHECK\" onclick=\"location.href='?C2'\"");
  if (led2 == true) {
    client.print(" checked");
  }
  client.print(">Led2<br>");
  client.print("<input type=\"checkbox\" name=\"CHECK\" onclick=\"location.href='?C3'\"");
  if (led3 == true) {
    client.print(" checked");
  }
  client.print(">Led3</P>");
  client.print("<P>LED の明るさ<br>");
  client.print("<input type=\"radio\" name=\"RADIO\" onclick=\" location.href='?R1'\"");
  if (select1 == 1) {
    client.print(" checked");
  }
  client.print("> 明るい</br>");
  client.print("<input type=\"radio\" name=\"RADIO\" onclick=\" location.href='?R2'\"");
  if (select1 == 2) {
    client.print(" checked");
  }
  client.print("> ふつう</br>");
  client.print("<input type=\"radio\" name=\"RADIO\" onclick=\" location.href='?R3'\"");
  if (select1 == 3) {
    client.print(" checked");
  }
  client.print("> 暗い</br>");
  client.println("</body>");
  client.println("</html>");
}
