#include <SPI.h>
#include <WiFi.h>
#include <Servo.h> // サーボモータを使うためのライブラリ

Servo myservo; // サーボモータを使うための宣言

char ssid[] = "planexuserwpa"; // Wi-Fi アクセスポイントの名前
char pass[] = "1234567890"; // パスワード
int keyIndex = 0;
int status = WL_IDLE_STATUS;
WiFiServer server(8080);

int slider1 = 0; // サーボモータの角度

void setup() {
  myservo.attach(9); // サーボモータの信号線をつなぐピンを設定
  myservo.write(0); // サーボモータの角度を0 度に
  Serial.begin(9600); // シリアル通信の通信速度を9600bps に設定
  while (!Serial); // シリアル通信が確立するまで待つ
  Serial.println("Edison start");

  while ( status != WL_CONNECTED) {
		// Wi-Fi 接続ができるまで繰り返す
    status = WiFi.begin(ssid, pass); // Wi-Fi で接続
    delay(1000); // 1 秒待つ
  }
  server.begin(); // Wi-Fi 接続の開始
  Serial.println(WiFi.localIP());
		// IP をシリアルモニタに表示
}

void loop() {
  WiFiClient client = server.available();
		// 接続しているクライアントを取得する
  if (client) { // 何か送られてきていれば以下を実行する
    Serial.println("new client");
		// シリアルモニタにnew client と表示
    String currentLine = ""; // 受信データの初期化
    while (client.connected()) {
		// 通信がつながっていれば以下を繰り返す
      if (client.available()) {
		// 何か送られてきていれば以下を実行する
        char c = client.read(); // 1 バイト読み込む
        Serial.write(c); // シリアルモニタにその文字を表示する
        if (c == '\n') { // もし￥n（改行コード）だったら
          Recieve(currentLine);
		// データを解析するためにRecieve 関数へ
          if (currentLine.length() == 0) {
		// 受信データの長さが0 だったら（最終行だったら）
            EdisonBoard(); // EdisonBoard 関数へ
            DisplayHTML(client);
		// 画面表示を更新するためにDisplayHTML 関数へ
            break;
          }
          else { // 受信データがの長さが0 でなかったら受信データを初期化
            currentLine = "";
          }
        }
        else if (c != '\r') { // ￥n でも￥r でもなければ
          currentLine += c;
		// 受信データをcurrentLine につなげる
        }

      }
    }
    client.stop(); // 通信が終わったときの処理
    Serial.println("client disconnected");
		// シリアルモニタにclientdisconnected と表示
  }
  delay(10);
}
//【 通信】
void Recieve(String currentLine)
{
  String v;
  char a;
  char b[20];
  int n, i;
  if (int(currentLine.indexOf("GET /?L:")) != -1) {
		// 受信データに「GET /?T1:」が含まれていれば
    n = currentLine.indexOf(":");
		//「 :」までの文字数をカウントする
    v = ""; // 受信データを文字列v に格納するための初期化
    for (i = 0; i < currentLine.length(); i++) {
		//「 :」の後の文字を a にコピー
      a = currentLine[n + 1 + i];
      if (a == ' ' || a == '&')
        break; //「 スペース」もしくは「＆」があれば終了
      v += a;
    }
    v.toCharArray(b, 20); // 文字列v から文字配列b へコピー
    slider1 = atoi(b); // b を数値に変換
  }
  return;
}
//【 回路】リスト 4.10 を参照
void EdisonBoard()
{
  myservo.write(slider1); // サーボモータの角度を変える
}
//【 画面】リスト 4.11 を参照
void DisplayHTML(WiFiClient client)
{
  client.println("HTTP/1.1 200 OK");
  client.println("Content-type:text/html");
  client.println();
  client.println("<form method=\"get\" action=\"\">");
  client.print("<input type=\"range\" id=\"slider01\" min=\"0\" max=\"120\" value=");
  client.print(slider1);
  client.print(" onchange=location.href=\"?L:\"+ document.getElementById('slider01').value>");
  client.print(slider1);
  client.println("</form>");
  client.println();
}
