#include <SPI.h>
#include <WiFi.h>

char ssid[] = "planexuserwpa"; // Wi-Fi アクセスポイントの名前
char pass[] = "1234567890"; // パスワード
int keyIndex = 0;
int status = WL_IDLE_STATUS;
WiFiServer server(8080);

boolean motor1 = false;
boolean read1 = false;
float temp, humi;

void setup() {
  pinMode(9, OUTPUT); // 出力に設定
  Serial.begin(9600); // シリアル通信の通信速度を9600bps に設定
  while (!Serial); // シリアル通信が確立するまで待つ
  Serial.println("Edison start");

  while ( status != WL_CONNECTED) {
		// Wi-Fi 接続ができるまで繰り返す
    status = WiFi.begin(ssid, pass); // Wi-Fi で接続
    delay(1000); // 1 秒待つ
  }
  Serial.println(WiFi.localIP()); // IP をシリアルモニタに表示
  server.begin(); // Wi-Fi 接続の開始
}

void loop() {
  WiFiClient client = server.available();
		// 接続しているクライアントを取得する
  if (client) { // 何か送られてきていれば以下を実行する
    Serial.println("new client");
		// シリアルモニタにnew client と表示
    String currentLine = ""; // 受信データの初期化
    while (client.connected()) {
		// 通信がつながっていれば以下を繰り返す
      if (client.available()) {
		// 何か送られてきていれば以下を実行する
        char c = client.read(); // 1 バイト読み込む
        Serial.write(c); // シリアルモニタにその文字を表示する
        if (c == '\n') { // もし￥n（改行コード）だったら
          Recieve(currentLine);
		// データを解析するためにRecieve 関数へ
          if (currentLine.length() == 0) {
		// 受信データの長さが0 だったら（最終行だったら）
            EdisonBoard();
		// モータを1 秒間回すためにEdisonBoard 関数へ
            DisplayHTML(client); // 温度と湿度を読み取って
		// 画面表示を更新するためにDisplayHTML 関数へ
            break;
          }
          else { // 受信データがの長さが0 でなかったら受信データを初期化
            currentLine = "";
          }
        }
        else if (c != '\r') { // ￥n でも￥r でもなければ
          currentLine += c; // 受信データをcurrentLine につなげる
        }

      }
    }
  client.stop(); // 通信が終わったときの処理
  Serial.println("client disconnected");
		// シリアルモニタにclient disconnected と表示
  }
  delay(10);
}
//【 通信】
void Recieve(String currentLine)
{
  int i = 0, n;
  if (int(currentLine.indexOf("GET /?B1")) != -1) {
		// 受信データに「GET /?B1」が含まれていれば
    read1 = true;; // read1 をtrue にする
  }
  else if (int(currentLine.indexOf("GET /?B2"))
    != -1) { // B1 と同様
    motor1 = true;; // motor1 をtrue にする
  }
  return;
}
//【 回路】リスト 4.13を参照
void EdisonBoard()
{
  if (read1 == true) {
    temp = analogRead(1) * 5 * 100 / 1024.0;
		// アナログ値を読み取って温度へ変換
    humi = analogRead(0) * 5 * 100 / 1024.0;
		// アナログ値を読み取って湿度へ変換
    read1 = false;
  }
  if (motor1 == true) {
    digitalWrite(9, HIGH); // モータを回す
    delay(1000); // 1 秒待つ
    digitalWrite(9, LOW); // モータを止める
    motor1 = false;
  }
}
//【 画面】リスト 4.14 を参照
void DisplayHTML(WiFiClient client)
{
  client.println("<!DOCTYPE html>");
  client.println("<html>");
  client.println("<head>");
  client.println("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">");
  client.println("<title>遠隔水やり</title>");
  client.println("</head>");
  client.println("<body>");
  client.print("<P> 温度：");
  client.print(temp);
  client.print("度<br>");
  client.print("<P> 湿度：");
  client.print(humi);
  client.print("％<br>");
  client.print("<input type=\"button\" name=\"BUTTON\" value=\"更新\" onclick=\"location.href='?B1' \"><br>");
  client.print("<inpututype=\"button\" name=\"BUTTON\" value=\"水やり\" onclick=\"location.href='?B2' \"><br>");
  client.println("</body>");
  client.println("</html>");
}
