#include <SPI.h>
#include <WiFi.h>

char ssid[] = "planexuserwpa";
		// 接続するWi-Fi アクセスポイントの名前
char pass[] = "1234567890"; // パスワード
int keyIndex = 0;
int status = WL_IDLE_STATUS;
WiFiServer server(8080);

int sensorReading[6];

void setup() {
  Serial.begin(9600); // シリアル通信の速度
  while (!Serial); // シリアル通信が確立するまで待つ
  Serial.println("Edison start");
  while ( status != WL_CONNECTED) {
    status = WiFi.begin(ssid, pass);
    delay(1000);
  }
  Serial.println(WiFi.localIP());
  server.begin();

  for (int analogChannel = 0; analogChannel < 6;
    analogChannel++) {
    sensorReading[analogChannel] = 0;
  }
}

void loop() {
  WiFiClient client = server.available();
		// 接続しているクライアントを取得する
  if (client) { // 何か送られてきていれば以下を実行する
    Serial.println("new client");
		// シリアルモニタにnew client と表示
  String currentLine = ""; // 受信データの初期化
  while (client.connected()) {
		// 通信がつながっていれば以下を繰り返す
    if (client.available()) {
		// 何か送られてきていれば以下を実行する
      char c = client.read(); // 1 バイト読み込む
      Serial.write(c); // シリアルモニタにその文字を表示する
      if (c == '\n') { // もし￥n（改行コード）だったら
        Recieve(currentLine);
		// データを解析するためにRecieve 関数へ
        if (currentLine.length() == 0) {
		// 受信データの長さが0 だったら（最終行だったら）
          EdisonBoard(); // EdisonBoard 関数へ
          DisplayHTML(client);
		// 画面表示を更新するためにDisplayHTML 関数へ
          break;
        }
        else {
		// 受信データがの長さが0 でなかったら受信データを初期化
          currentLine = "";
        }
      }
      else if (c != '\r') { // ￥n でも￥r でもなければ
        currentLine += c;
		// 受信データをcurrentLine につなげる
      }

    }
  }
  client.stop(); // 通信が終わったときの処理
  Serial.println("client disconnected");
		// シリアルモニタにclient disconnected と表示
  }
  delay(10);
}
//【 通信】自動更新時は操作するための情報がないため空
void Recieve(String currentLine)
{
}
//【 回路】リスト 4.16を参照
void EdisonBoard()
{
  for (int analogChannel = 0; analogChannel < 6;
    analogChannel++) {
    sensorReading[analogChannel] = analogRead
    (analogChannel); // アナログ値を読み取る
  }
}
//【 画面】リスト 4.17を参照
void DisplayHTML(WiFiClient client)
{
  client.println("HTTP/1.1 200 OK");
  client.println("Content-Type: text/html");
  client.println("Connection: close");
  client.println("Refresh: 5"); // 5 秒おきに更新する設定
  client.println();
  client.println("<!DOCTYPE HTML>");
  client.println("<html>");
  for (int analogChannel = 0; analogChannel < 6;
    analogChannel++) {
    client.print("analog input ");
    client.print(analogChannel);
    client.print(" is ");
    client.print(sensorReading[analogChannel]);
    client.println("<br />");
  }
  client.println("</html>");
}
